"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeMapGenerator = void 0;
var lib_1 = require("@stringifyrjs/lib");
var _ = __importStar(require("lodash"));
var TypeMap_1 = require("./TypeMap");
var TypeMapGeneratorBase = /** @class */ (function () {
    function TypeMapGeneratorBase() {
        this.typeMap = function (typeMap) {
            var result = {};
            for (var _i = 0, typeMap_1 = typeMap; _i < typeMap_1.length; _i++) {
                var _a = typeMap_1[_i], resolver = _a[0], value = _a[1];
                var variantTypeMapTree = exports.TypeMapGenerator.resolverTypeMap(resolver, value);
                exports.TypeMapGenerator.mergeTypeMapTree(result, variantTypeMapTree);
            }
            return result;
        };
        /**
         * todo comment
         * @param resolver
         * @param value
         */
        this.resolverTypeMap = function (resolver, value) {
            var resolverSegments = lib_1.Resolver.split(resolver);
            var stringValueVariables = lib_1.Value.toVariables(value);
            var deep = resolverSegments.reverse().reduce(function (acc, segment) {
                var _a, _b;
                var _c, _d;
                var result = {
                    __def: {
                        // The variables of a parent are always a superset of the
                        // variables of a child
                        // E.g if a child has a variable 'a' then a parent always has the variable 'a'
                        __variables: _.cloneDeep((_c = acc.__def.__variables) !== null && _c !== void 0 ? _c : {}),
                    },
                };
                function addResolverParent(parent) {
                    var _a;
                    _.merge(result.__def, {
                        resolvers: __assign((_a = {}, _a[parent] = {}, _a), _.mapKeys(acc.__def.resolvers, function (val, childResolver) {
                            return lib_1.Segment.join(parent, childResolver);
                        })),
                    });
                }
                // Add the base segment
                result[segment] = _.cloneDeep(acc);
                addResolverParent(segment);
                // Add the variable name segment
                var variable = lib_1.Segment.toVariable(segment);
                if (variable) {
                    // Add the missing variable since this is the
                    // un-valued variable segment
                    _.merge(result.__def.__variables, TypeMap_1.TypeMap.recordToTypeMapVariableTypes((_a = {},
                        _a[variable.name] = variable.value,
                        _a)));
                    var templateSegment = lib_1.Variable.toTemplateSegment(variable);
                    result[templateSegment] = __assign(__assign({}, _.cloneDeep(acc)), { __def: _.merge((_d = acc.__def) !== null && _d !== void 0 ? _d : {}, {
                            __variables: TypeMap_1.TypeMap.recordToTypeMapVariableTypes((_b = {},
                                _b[variable.name] = variable.value,
                                _b)),
                        }) });
                    addResolverParent(templateSegment);
                }
                return result;
            }, {
                __def: {
                    __variables: TypeMap_1.TypeMap.recordToTypeMapVariableTypes(stringValueVariables),
                },
            });
            return deep;
        };
        /**
         * todo comment
         */
        this.mergeTypeMapTree = function (tmt1, tmt2) {
            return _.mergeWith(tmt1, tmt2, function (objValue, srcValue, key) {
                if (key === '__variables') {
                    return _.mergeWith(objValue, srcValue, function (varObjValue, srcObjValue) {
                        return _.uniq(srcObjValue.concat(varObjValue !== null && varObjValue !== void 0 ? varObjValue : [])).sort(function (a, b) { return a < b ? -1 : 1; });
                    });
                }
            });
        };
        // Singleton for caching purposes
    }
    return TypeMapGeneratorBase;
}());
exports.TypeMapGenerator = new TypeMapGeneratorBase();
